# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%if "%{?rhel}" == "6"
%bcond_without repolib
%else
%bcond_with repolib
%endif
%bcond_without mead

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/%{name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-build
Version:        1.0.13
Release:        3%{?dist}
Epoch:          0
Summary:        JBoss EJB3 build pom
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-build-1.0.13 && tar cjf jboss-ejb3-build-1.0.13.tar.bz2 jboss-ejb3-build-1.0.13
Source0:        jboss-ejb3-build-1.0.13.tar.bz2
Source1:        jboss-ejb3-build-settings.xml
Source2:        jboss-ejb3-build-component-info.xml
Patch0:         jboss-ejb3-build-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jboss-parent
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:	maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:	maven2-plugin-rar
BuildRequires:  maven2-plugin-release
BuildRequires:	maven2-plugin-source
BuildRequires:	maven-jboss-deploy-plugin
BuildRequires:	maven-surefire-maven-plugin
BuildRequires:	jboss-parent
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB3 build pom.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1 -b .sav0

%{__cp} -p %{SOURCE1} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file:`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build

export M2_SETTINGS=`pwd`/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2_SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=jboss-releases::default::file:`pwd`/maven2-brew \
        deploy:deploy

%install
%{__rm} -rf %{buildroot}

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 jboss-ejb3-build %{namedversion} JPP %{name}

%if %with repolib
%if %without mead
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{version}-brew`
%{__sed} -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jboss-ejb3-build.pom
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Feb 24 2011 David Walluck <dwalluck@redhat.com> 0:1.0.13-3
- add back org.jboss.javaee:jboss-servlet-api:2.5.0.GA to pom.xml

* Fri Feb 18 2011 David Walluck <dwalluck@redhat.com> 0:1.0.13-2
- patch pom to use jbossweb-servlet-2.5-api
- Requires: jpackage-utils
- Requires: jboss-parent
- fix maven call not using local repo
- fix repolib dir ownership
- fix maven2 deps to be backwards compatible with maven 2.0.8

* Wed Feb 16 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.0.13-1
- Move build to MEAD

* Fri Jan 14 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.13-0.6
- Rebuild for MEAD

* Mon Nov 22 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.13-0.5
- Add maven deploy for pom.xml upload to repositories

* Mon Nov 15 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.13-0.4
- Fix pom patch to actually allow maven 2.2.1

* Mon Nov 15 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.13-0.3
- Update pom patch to allow maven 2.2.1
- Build with maven 2.2.1

* Tue Aug 17 2010 David Walluck <dwalluck@redhat.com> 0:1.0.13-0.2
- patch out org.jboss.maven.plugins.enforcer.rules:nocompiledep

* Tue Aug 17 2010 David Walluck <dwalluck@redhat.com> 0:1.0.13-0.1
- 1.0.13
- fix pom name
- fix repolib

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.9-1.1.1
- rebuilt

* Tue Apr 6 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.9-1.1
- Rebuild

* Thu Jan 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.9-1
- Upgrade to 1.0.9

* Mon Dec 07 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.8-2
- Fix component id in component info.xml

* Mon Dec 07 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.8-1
- Upgrade to 1.0.8
- Add repolib

* Tue Jul 21 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.4-2.jpp6
- relax enforcement
- omit apiviz doclet

* Tue Jul 21 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.4-1.jpp6
- first release

